/* //////////////////////////////////////////////////////////////////////// */
/* // emutil.h //////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emlib [ Aka Event Monitor Library ]
//
// this library provides you an API for send messages to the
// server from inside programs written in C.
//
// 
// This program is part of Event Monitor project (EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//



#ifndef __LIBEM_H__
#define __LIBEM_H__

#include <sys/vfs.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <netdb.h>
#include <string.h>
#include <strings.h>
#include <netinet/in.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>

#define DEBUG 2                   /* some debug level flag                 */
#define MAX_CAD 256               /* max length of a string                */
#define MAX_PET 5                 /* max num of connections to the servers */
#define MAX_BUFFER 9036           /* max size of a buffer                  */
#define CMARK "#"                 /* comment sign                          */
#define ADDR_LEN 16               /* max length of a INET address in ASCII */
#define MAX_TRANS 512             /* max number of transmissions           */
#define SEM_KEY 255               /* [ obsolete ] key for a semaphore      */
#define SEM_NUM 1                 /* [ obsolete ] semaphore ID             */
#define SLEEP_TIME 2              /* [ obsolete ] sleep time on seconds    */

struct fs_info {                  /* info about the filesystem             */
      char name[MAX_CAD];         /* name of filesystem                    */
      float level;                /* below this, warning level             */
};

extern int new_socket(int dominio, int tipo,int port, 
		      char *ip_address, char bindit);
extern void error(char num, char *cad);
extern void clear_string(char *cad);
extern int is_num(char *cad);
extern int strip_comment(char *str);
extern void prepare_string(char *cad);
extern void read_cad(FILE *f, char *cad);
extern int send_data(char *buffer, char *hname, char *S_ERVER, int P_ORT);
extern void generate_message(int level, char *group, char *buff, char *msg);
extern int send_message(char *host, long port, 
	int level, char *group, char *msg);
extern int send_message_raw(char *host, long port, char *msg);
extern void parse_address(struct sockaddr_in addr, char *cad);
extern void s2upper(char *cad);
#endif
