/* //////////////////////////////////////////////////////////////////////// */
/* // emputcmd.c ////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emputcmd [ Aka Event Put Command ]
//
// this tools sends a command to a server
// command running on the managed station
// 
// This program is part of Event Monitor project (EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//
// WARNING
// this code is under heavy modifications,
// so no documentation nor helpers are
// provided. Soon will appear an estable
// version. 
// 
// If you compile it, its functional, 
// but is under changes and tests
//
// sorry a lot.
//

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <netdb.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <netinet/in.h>

#include <sys/time.h>
#include <time.h>


#include "misc.h"

#define CFILE "/opt/em/etc/emputcmd.conf"
#define ENV_VAR_DIR "EMPUTCMD_CONF"

/* //////////////////////////////////////////////////////////////////////// */
/* // Send_data() ///////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

int send_data(char *F_LOG, char *buffer, char *hname, 
	      char *S_ERVER, int P_ORT) {
int socketfd;
int n=0;
struct hostent *host, *srv;
struct sockaddr_in srv_address;

  if ((host=gethostbyname("127.0.0.1"))==NULL) error(7,hname);
  socketfd=new_socket(AF_INET,SOCK_STREAM,P_ORT,host->h_addr,0);

  if ((srv=gethostbyname(S_ERVER))==NULL) error(1,hname); 

  srv_address.sin_family=AF_INET;
  srv_address.sin_port=ntohs(P_ORT);
  srv_address.sin_addr.s_addr=*(long *)srv->h_addr;

  if (connect(socketfd,
	      (struct sockaddr *)&srv_address,sizeof(srv_address))==-1) {
    return -1;
  }

  n=sendto(socketfd,buffer,strlen(buffer),0,
		(struct sockaddr *)&srv_address,sizeof(srv_address));

  close(socketfd);
 return n;
}

/* //////////////////////////////////////////////////////////////////////// */
/* // load() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void load(char *CF, char *HFILE) {
FILE *f=NULL;

f=fopen(CF,"r");
if (f==NULL) { printf("Can't open %s\n",CF); exit(1); }

 bzero(HFILE,MAX_CAD);
 fgets(HFILE,MAX_CAD,f);
 if (strlen(HFILE)==0)  { 
   printf("%s is corrupt\n",CF);
   exit(-1);
 }
 clear_string(HFILE); 
 fclose(f);
}


/* //////////////////////////////////////////////////////////////////////// */
/* // main() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void main(int argc, char *argv[]) {
  FILE *f;
  char hname[MAX_CAD];
  char buffer2[MAX_BUFFER];
  char SERVER[MAX_CAD];
  long PORT;
  char FLOG[MAX_CAD];
  char *NFLOG;
  char HFILE[MAX_CAD];
  char alias[MAX_CAD];
  char name[MAX_CAD];

  NFLOG=getenv(ENV_VAR_DIR);
  if (NFLOG!=NULL) load(NFLOG,HFILE);
  else load(CFILE,HFILE);

  /* // Comprobacion de parametros /////////////////////////////////////// */

  if (argc != 4) {
    printf("\nuso: %s <host> <port> <action>\n\n",argv[0]);
    exit(1);
  }

  /* // Creacion de la cadena de envio /////////////////////////////////// */ 

  bzero(hname,sizeof(hname));   /* extraigo el nombre del host donde estoy */
  gethostname(hname,sizeof(hname));    

  strcpy(SERVER,argv[1]);

  /* compruebo si tiene alias */

  f=NULL;
  f=fopen(HFILE,"r");
  if (f!=NULL) {
    while (!feof(f)) {
      if (fscanf(f,"%s %s",name,alias)<0) break;
      if (strcmp(name,argv[1])==0) {
	strcpy(SERVER,alias);
	break;
      }
    }
  }
  fclose(f);

  PORT=atoi(argv[2]);
  
  bzero(buffer2,sizeof(buffer2));
  sprintf(buffer2,"%s",argv[3]);

    if (send_data(FLOG,buffer2,hname,SERVER,PORT)<0) {
      error(4,hname);
    } 
    
}	
