/* //////////////////////////////////////////////////////////////////////// */
/* // emputmsg.c ////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emputmsg [ Aka Event Monitor Put Message ]
//
// this programs lets you send messages to a server
// for example, inside a script
// 
// This program part of Event Monitor Project (EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//
// Usage: emputmsg level group text
//
//
// level    a range between 0 and 9 [ 0 is lowest priority, 9 is highest ]
// group    a path or alias to asign this message to a group
// text     some text to describe de problem briefly
//
//


#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <signal.h>
#include <netdb.h>
#include <string.h>
#include <strings.h>
#include <unistd.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <time.h>

#include "libem.h"

/* //////////////////////////////////////////////////////////////////////// */
/* // Encola() //////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void encola(char *name, char *buff) {
FILE *f;
f=fopen(name,"a");
fprintf(f,"%s\n",buff);
fclose(f);
}


/* //////////////////////////////////////////////////////////////////////// */
/* // load() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void load(char *CF, char *SRV, long *PRT, char *FLOG) {
FILE *f=NULL;
char cad[MAX_CAD];



f=fopen(CF,"r");
if (f==NULL) error(9,CF); 

*PRT=0;
bzero(SRV,MAX_CAD);
bzero(FLOG,MAX_CAD);

   read_cad(f,cad);
   if (sscanf(cad,"%s %ld",SRV,PRT)!=2) error(8,CF);
   read_cad(f,cad);
   if (sscanf(cad,"%s",FLOG)!=1) error(8,CF);

fclose(f);
}


/* //////////////////////////////////////////////////////////////////////// */
/* // main() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void main(int argc, char *argv[]) {
  FILE *f;

  char buffer2[MAX_BUFFER];
  char buffer3[MAX_BUFFER];
  char SERVER[MAX_CAD];
  long PORT;
  char buffer[MAX_BUFFER];
  char FLOG[MAX_CAD];
  char *NFLOG;

  /*  int new_socketfd; */
  /*  int cli_size;     */
  /*  int childpid;     */

  int n;


  NFLOG=getenv(ENV_VAR_DIR);
  if (NFLOG!=NULL) load(NFLOG,SERVER,&PORT,FLOG);
  else load(CFILE,SERVER,&PORT,FLOG);

  /* // Comprobacion de parametros /////////////////////////////////////// */

  if (argc < 4) {
    printf("\nuso: %s <nivel> <grupo> <texto>\n\n",argv[0]);
    exit(1);
  }

  /* // es un numero ? // */

  if ((!is_num(argv[1])) || ((atoi(argv[1])<0) || (atoi(argv[1])>9))) {
    printf("\nnivel [%s] debe de estar entre 0 y 9\n\n",argv[1]);
    exit(1);
  }
		    
  /* mando id primero */

  bzero(buffer,MAX_CAD);
  for (n=3; n< argc; n++) {
    strcat(buffer,argv[n]);
    strcat(buffer," ");
  }

  // send_message(SERVER,PORT,atoi(argv[1]),argv[2],buffer);

  /* // enviamos o en caso de error encolamos /////////////////////////// */ 

    /* desencolo lo que me quede dentro del spool */
    bzero(buffer2, sizeof(buffer2));			     
    bcopy(buffer,buffer2,sizeof(buffer));

    f=fopen(FLOG,"r");
    if (f!=NULL) {
      while (!feof(f)) {
	if (fgets(buffer,sizeof(buffer),f)==NULL) break;
	clear_string(buffer);	
        if (send_message_raw(SERVER,PORT,buffer)<0) {
	  fclose(f);

	  generate_message(atoi(argv[1]),argv[2],buffer2,buffer3);
	  encola(FLOG,buffer3);
	  error(4,SERVER);
	}   
      }
      fclose(f);
      remove(FLOG);
    }

    if (send_message(SERVER,PORT,atoi(argv[1]),argv[2],buffer2)<0) {

      generate_message(atoi(argv[1]),argv[2],buffer2,buffer3);
      encola(FLOG,buffer3);
      error(4,SERVER);
    } 
    
}	
